#!/usr/bin/env python

import os
import re
import datetime

twitter = []
instagram = []
mastodon = []
github = []
found = []

for filename in os.listdir('/home'):

    s = ''
    try:
        s = open('/home/' + filename + '/public_html/index.html', 'r').read()
    except:
        continue

    tw = re.findall(r'twitter\.com\/[a-z0-9A-Z_]+',s)
    ma = re.findall(r'[a-zA-Z0-9\.]+\/@[a-z0-9A-Z_]+',s)
    ig = re.findall(r'instagram\.com\/[a-z0-9A-Z_]+',s)
    gh = re.findall(r'github\.com\/[a-z0-9A-Z_]+',s)

    if len(tw):
        for item in tw:
            if item not in found and item != 'twitter.com/widgets':
                twitter.append({
                    'url': item,
                    'username': filename
                })
                found.append(item)

    if len(ma):
        for item in ma:
            if item not in found and "medium.com" not in item:
                mastodon.append({
                    'url': item,
                    'username': filename
                })
                found.append(item)

    if len(ig):
        for item in ig:
            if item not in found:
                instagram.append({
                    'url': item,
                    'username': filename
                })
                found.append(item)

    if len(gh):
        for item in gh:
            if item not in found and 'images' not in item:
                github.append({
                    'url': item,
                    'username': filename
                })
                found.append(item)

print '<html><body><link href="https://fonts.googleapis.com/css?family=Roboto+Mono:300,700" rel="stylesheet"><style type="text/css">body {background-color:#1C1C1C;color: #fff;font-family: "Roboto Mono", "Hack", "Inconsolata", monospace;}a{color:#00AAEE;}</style>'

print '[*] <strong>Updated at:</strong> &nbsp;' + str(datetime.datetime.now()) + '<br>'
print '[*] <strong>Total count:</strong> ' + str(len(github)+len(twitter)+len(mastodon)+len(instagram)) + '<br><br>'

print '<strong>[*] github</strong> (' + str(len(github)) + ')<br>'

for item in github:
    print '[G] <a href="https://' + item['url'] + '" target="_blank">' + item['url'] + '</a> (<a href="http://ctrl-c.club/~' + item['username'] + '" target="_blank">~' + item['username'] + '</a>)<br>'

print '<br><br>'

print '<strong>[*] twitter</strong> (' + str(len(twitter)) + ')<br>'

for item in twitter:
    print '[T] <a href="https://' + item['url'] + '" target="_blank">' + item['url'] + '</a> (<a href="http://ctrl-c.club/~' + item['username'] + '" target="_blank">~' + item['username'] + '</a>)<br>'

print '<br><br>'

print '<strong>[*] mastodon</strong> (' + str(len(mastodon)) + ')<br>'

for item in mastodon:
    print '[M] <a href="https://' + item['url'] + '" target="_blank">' + item['url'] + '</a> (<a href="http://ctrl-c.club/~' + item['username'] + '" target="_blank">~' + item['username'] + '</a>)<br>'

print '<br><br>'

print '<strong>[*] instagram</strong> (' + str(len(instagram)) + ')<br>'

for item in instagram:
    print '[I] <a href="https://' + item['url'] + '" target="_blank">' + item['url'] + '</a> (<a href="http://ctrl-c.club/~' + item['username'] + '" target="_blank">~' + item['username'] + '</a>)<br>'

print '</body></html>'
